## seriousproton 2020.01.15+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(SeriousProton)
set(CMAKE_MODULE_PATH
	${CMAKE_SOURCE_DIR}/cmake/
	${CMAKE_MODULE_PATH}
)

#---------------------------------File lists-----------------------------------
set(source_files_relative #All SeriousProton's objects to compile
	src/clipboard.cpp
	src/collisionable.cpp
	src/engine.cpp
	src/event.cpp
	src/fixedSocket.cpp
	src/gameEntity.cpp
	src/httpServer.cpp
	src/input.cpp
	src/logging.cpp
	src/multiplayer.cpp
	src/multiplayer_client.cpp
	src/multiplayer_server.cpp
	src/multiplayer_server_scanner.cpp
	src/networkAudioStream.cpp
	src/networkRecorder.cpp
	src/PlayerController.cpp
	src/postProcessManager.cpp
	src/random.cpp
	src/Renderable.cpp
	src/resources.cpp
	src/scriptInterface.cpp
	src/scriptInterfaceMagic.cpp
	src/shaderManager.cpp
	src/soundManager.cpp
	src/stringImproved.cpp
	src/textureManager.cpp
	src/tween.cpp
	src/Updatable.cpp
	src/windowManager.cpp
)
set(source_files "")
foreach(source_file_relative ${source_files_relative})
	list(APPEND source_files ${CMAKE_CURRENT_SOURCE_DIR}/${source_file_relative})
endforeach()

set(seriousproton_include_dir ${CMAKE_CURRENT_SOURCE_DIR}/src/)

include_directories(
	${CMAKE_CURRENT_BINARY_DIR}
	${CMAKE_CURRENT_SOURCE_DIR}/src
)

#----------------------------------Compiling-----------------------------------
if(CMAKE_VERSION VERSION_LESS "3.1")
	if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
		set(CMAKE_CXX_FLAGS "-std=gnu++11 ${CMAKE_CXX_FLAGS}")
	endif()
else()
	set(CMAKE_CXX_STANDARD 11)
endif()

add_library(seriousproton STATIC ${source_files})

#--------------------------------Dependencies----------------------------------
include(ExternalProject)

add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/src/Box2D)
add_dependencies(seriousproton box2d)

add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/src/lua)
add_dependencies(seriousproton lua)

add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/src/GL)
add_dependencies(seriousproton glew)

find_package(SFML 2.3 COMPONENTS system audio network window graphics)
if(NOT ${SFML_FOUND})
	message(STATUS "Couldn't find SFML. Building it from scratch. Installing to ${CMAKE_INSTALL_PREFIX}")
	ExternalProject_Add(SFML
		GIT_REPOSITORY https://github.com/SFML/SFML.git
		GIT_TAG 2.4.2 #Always build with this tag, so we're sure it is stable.
		CMAKE_ARGS -DCMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX} -DBUILD_SHARED_LIBS=OFF
	)
	set(SFML_INCLUDE_DIR ${CMAKE_INSTALL_PREFIX}/include) #Otherwise this is filled by FindSFML.cmake.
	set(SFML_LIBRARIES
		${CMAKE_INSTALL_PREFIX}/lib/${CMAKE_STATIC_LIBRARY_PREFIX}sfml-audio${CMAKE_STATIC_LIBRARY_SUFFIX}
		${CMAKE_INSTALL_PREFIX}/lib/${CMAKE_STATIC_LIBRARY_PREFIX}sfml-graphics${CMAKE_STATIC_LIBRARY_SUFFIX}
		${CMAKE_INSTALL_PREFIX}/lib/${CMAKE_STATIC_LIBRARY_PREFIX}sfml-network${CMAKE_STATIC_LIBRARY_SUFFIX}
		${CMAKE_INSTALL_PREFIX}/lib/${CMAKE_STATIC_LIBRARY_PREFIX}sfml-system${CMAKE_STATIC_LIBRARY_SUFFIX}
		${CMAKE_INSTALL_PREFIX}/lib/${CMAKE_STATIC_LIBRARY_PREFIX}sfml-window${CMAKE_STATIC_LIBRARY_SUFFIX}
	)
	add_dependencies(seriousproton SFML)
endif()
include_directories(${SFML_INCLUDE_DIR})
target_link_libraries(seriousproton ${SFML_LIBRARIES})

#--------------------------------Installation----------------------------------
install(
	TARGETS seriousproton
	EXPORT seriousproton
	LIBRARY DESTINATION lib
	ARCHIVE DESTINATION lib
)
install(
	DIRECTORY ${seriousproton_include_dir}
	DESTINATION include/seriousproton
	FILES_MATCHING PATTERN "*.h"
)
install(
	DIRECTORY ${seriousproton_include_dir}
	DESTINATION include/seriousproton
	FILES_MATCHING PATTERN "*.hpp"
)
install(
	EXPORT seriousproton
	DESTINATION share/seriousproton
)

=== src/json11/Makefile ===
# Environment variable to enable or disable code which demonstrates the behavior change
# in Xcode 7 / Clang 3.7, introduced by DR1467 and described here:
# https://llvm.org/bugs/show_bug.cgi?id=23812
# Defaults to on in order to act as a warning to anyone who's unaware of the issue.
ifneq ($(JSON11_ENABLE_DR1467_CANARY),)
CANARY_ARGS = -DJSON11_ENABLE_DR1467_CANARY=$(JSON11_ENABLE_DR1467_CANARY)
endif

test: json11.cpp json11.hpp test.cpp
	$(CXX) $(CANARY_ARGS) -O -std=c++11 json11.cpp test.cpp -o test -fno-rtti -fno-exceptions

clean:
	if [ -e test ]; then rm test; fi

.PHONY: clean

## seriousproton 2019.05.21+dfsg

=== debian/changelog ===
seriousproton (2019.05.21+dfsg-1) unstable; urgency=medium

  * Initial packaging (Closes: #854916)

 -- Nicolas Braud-Santoni <nicoo@debian.org>  Mon, 12 Aug 2019 13:22:29 +0200

=== debian/control ===
Source: seriousproton
Maintainer: Nicolas Braud-Santoni <nicoo@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 12), cmake, pkgconf,
               libbox2d-dev, libglew-dev, liblua5.3-dev, libsfml-dev
Rules-Requires-Root: no
Standards-Version: 4.4.0
Homepage: https://github.com/daid/SeriousProton

Package: libseriousproton-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
         libseriousproton0 (= ${binary:Version})
Description: C++ game engine -- development files
 SeriousProton is implemented atop SFML, from scratch.
 .
 “There will be dragons and undocumented stuff in here.”
 .
 This package contains the development files (CMake, headers, ...)

Package: libseriousproton0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ game engine -- shared library
 SeriousProton is implemented atop SFML, from scratch.
 .
 “There will be dragons and undocumented stuff in here.”
 .
 This package contains the shared library.

=== debian/watch ===
version=4
opts=repacksuffix=+dfsg,repack,compression=xz,dversionmangle=s/\+dfsg\d*$//,\
filenamemangle=s%.*/EE-(\d\S+)\.tar\.gz%seriousproton-$1\.tar\.gz% \
  https://github.com/daid/SeriousProton/releases .*/EE-(\d\S+)\.tar\.gz

## seriousproton 2020.01.15+dfsg

=== debian/changelog ===
seriousproton (2020.01.15+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Declare compliance with policy v4.5.0.
    No change required.

 -- Nicolas Braud-Santoni <nicoo@debian.org>  Thu, 30 Jan 2020 20:26:09 +0100

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,10 @@
 Build-Depends: debhelper-compat (= 12), cmake, pkgconf,
                libbox2d-dev, libglew-dev, liblua5.3-dev, libsfml-dev
 Rules-Requires-Root: no
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
 Homepage: https://github.com/daid/SeriousProton
+Vcs-Browser: https://salsa.debian.org/games-team/seriousproton
+Vcs-Git: https://salsa.debian.org/games-team/seriousproton.git
 
 Package: libseriousproton-dev
 Section: libdevel

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_missing:
	dh_missing --fail-missing

override_dh_installdocs:
	dh_installdocs --link-doc=libseriousproton0

=== debian/watch ===
version=4
opts="repack, repacksuffix=+dfsg, dversionmangle=s/\+dfsg\d*$//,\
      compression=xz, mode=git" \
  https://github.com/daid/SeriousProton.git refs/tags/EE-(\d\S+)
